%define anolis_release 1

%undefine _package_note_flags

# To build all parts of alcotest requires the async, js_of_ocaml, and lwt
# packages.  The async package in particular requires many packages that test
# with alcotest.  We build only the base alcotest package to break the circular
# dependency.
%bcond_with async

%global srcname alcotest

Name:           ocaml-%{srcname}
Version:        1.6.0
Release:        %{anolis_release}%{?dist}
Summary:        Lightweight and colorful test framework for OCaml

License:        ISC
URL:            https://github.com/mirage/alcotest
Source0:        %{url}/archive/%{version}/%{srcname}-%{version}.tar.gz

Patch0:         0001-Drop-the-stdlib-shims-subpackage.patch

BuildRequires:  ocaml >= 4.05.0
BuildRequires:  ocaml-astring-devel
BuildRequires:  ocaml-cmdliner-devel >= 1.1.0
BuildRequires:  ocaml-dune >= 2.0
BuildRequires:  ocaml-fmt-devel >= 0.8.7
BuildRequires:  ocaml-re-devel >= 1.7.2
BuildRequires:  ocaml-uutf-devel >= 1.0.1

%if %{with async}
BuildRequires:  js-of-ocaml-compiler-devel >= 3.11.0
BuildRequires:  ocaml-async-devel >= 0.15.0
BuildRequires:  ocaml-async-kernel-devel
BuildRequires:  ocaml-async-unix-devel >= 0.15.0
BuildRequires:  ocaml-base-devel
BuildRequires:  ocaml-core-devel >= 0.15.0
BuildRequires:  ocaml-core-unix-devel >= 0.15.0
BuildRequires:  ocaml-logs-devel
BuildRequires:  ocaml-lwt-devel
%endif

%description
Alcotest is a lightweight and colorful test framework.

Alcotest exposes a simple interface to perform unit tests, including a
simple `TESTABLE` module type, a `check` function to assert test
predicates, and a `run` function to perform a list of `unit -> unit`
test callbacks.

Alcotest provides quiet and colorful output where only faulty runs are
fully displayed at the end of the run (with the full logs ready to
inspect), with a simple (yet expressive) query language to select the
tests to run.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       ocaml-astring-devel
Requires:       ocaml-cmdliner-devel
Requires:       ocaml-fmt-devel
Requires:       ocaml-re-devel
Requires:       ocaml-uutf-devel

%if %{with async}
Requires:       ocaml-async-devel
Requires:       ocaml-lwt-devel
%endif

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{srcname}-%{version} -p1

%build
%if %{with async}
%dune_build
%else
%dune_build -p alcotest
%endif

# Relink the stublibs with $RPM_LD_FLAGS.
cd _build/default/src
ocamlmklib -g -ldopt '%{build_ldflags}' -o alcotest_stubs \
  $(ar t libalcotest_stubs.a)
cd -

%install
%if %{with async}
%dune_install
%else
%dune_install alcotest
%endif

%generate_compatibility_deps

%check
%if %{with async}
%dune_check
%else
%dune_check -p alcotest
%endif

%files -f .ofiles
%license LICENSE.md
%dir %{abidir}
%{abidir}/dllalcotest_stubs.dump

%files devel -f .ofiles-devel

%files doc
%doc CHANGES.md README.md alcotest-help.txt

%changelog
* Fri Mar 24 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.6.0-1
- Init from upstream
